<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="Content-Type" content="text/html" charset="utf-8">
    <title>HMMTeacher</title>
    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
</head>
<body>
<div class="container">
    <div class="p-5 mb-4 bg-light rounded-3">
        <div class="container-fluid py-5">
            <h1 class="display-5 fw-bold">{{ report_title }}</h1>
            <p class="col-md-8 fs-4">{{ now() }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Observed sequence
                </div>
                <div class="card-body">
                    <p>{{ observed_chain }}</p>
                </div>
            </div>
        </div>
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Alphabet
                </div>
                <div class="card-body">
                    <ul>
                        <li>{{ alphabet }}</li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Hidden States
                </div>
                <div class="card-body">
                    <ul>
                        {% for state in hidden_states %}
                        <li>{{ state }}</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Selected algorithms
                </div>
                <div class="card-body">
                    <ol>
                        {% for alg in algorithms %}
                        {% if 'fo' in alg %}
                        <li>Forward</li>
                        {% endif %}
                        {% if 'ba' in alg %}
                        <li>Backward</li>
                        {% endif %}
                        {% if 'vi' in alg %}
                        <li>Viterbi</li>
                        {% endif %}
                        {% endfor %}
                    </ol>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Transition matrix
                </div>
                <div class="card-body">
                    <div class="table-responsive">
                        {{ transition_data }}
                    </div>
                </div>
            </div>
        </div>
        <div class="col">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Emission matrix
                </div>
                <div class="card-body">
                    <div class="table-responsive">
                        {{ emission_data }}
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Prior Probabilities
                </div>
                <div class="card-body">
                    <ul>
                        {% for key, value in prior_values_data.items() %}
                        <li><b>{{ key }}</b> : {{ value }}</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
        {% if not backward_options %}
        <div class="col-3">
            <div class="card bg-light mb-3">
                <div class="card-header">
                    Backward Options
                </div>
                <div class="card-body">
                    <ul>
                        {% for opt in backward_options %}
                        <li>{{opt}}</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
        {% endif %}
    </div>
</div>
<div class="container">
    <div class="card border-dark">
        <div class="card-header">
            <ul class="nav nav-tabs card-header-tabs" id="algoTab" role="tablist">
                {% for alg in algorithms %}
                {% if 'fo' in alg %}
                <li class="nav-item" role="presentation">
                    <button class="nav-link active" id="forward-tab" data-bs-toggle="tab" data-bs-target="#forward"
                            type="button" role="tab" aria-controls="forward" aria-selected="true">Forward
                    </button>
                </li>
                {% endif %}
                {% if 'vi' in alg %}
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="viterbi-tab" data-bs-toggle="tab" data-bs-target="#viterbi"
                            type="button" role="tab" aria-controls="viterbi" aria-selected="false">Viterbi
                    </button>
                </li>
                {% endif %}
                {% if 'ba' in alg %}
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="backward-tab" data-bs-toggle="tab" data-bs-target="#backward"
                            type="button" role="tab" aria-controls="backward" aria-selected="false">Backward
                    </button>
                </li>
                {% endif %}
                {% endfor %}
            </ul>
        </div>
        <div class="card-body tab-content" id="algoContent">
            {% for alg in algorithms %}
            {% if 'fo' in alg %}
            <div class="tab-pane fade show active" id="forward" role="tabpanel" aria-labelledby="forward-tab">
                <h1 class="card-title">Forward</h1>
                <p class="card-text h4">Initialization</p>
                \[
                \alpha(t=1, i)=\pi_{i} \bullet e_{S_{i}}\left(O_{t=1}\right)
                \]
                <br><b>T: 1</b><br>
                {{ forward_init_text }}
                <br>
                <p class="card-text h4">Recursion</p>
                \[
                \alpha(t, i)=e_{q_{t}=S_{i}}\left(O_{t}\right) \cdot \sum_{j=1}^{N} \alpha(t-1, j) \cdot a_{j i} \quad \forall i
                \]
                {{ forward_rec_text }}
                <br>
                <p class="card-text h4">Termination</p><br>
                \[
                P(O)=\sum_{i=1}^{N} \alpha(L, i)
                \]
                <br>
                {{ forward_term_text }}
                <br><br>
                <p class="h4">Matrix of &alpha; values</p><br>
                <div class="table-responsive">
                    {{ forward_matrix }}
                </div>
            </div>
            {% endif %}
            {% if 'vi' in alg %}
            <div class="tab-pane fade" id="viterbi" role="tabpanel" aria-labelledby="viterbi-tab">
                <h1 class="card-title">Viterbi</h1>
                <p class="card-text h4">Initialization</p>
                \[
                \begin{aligned}
                &\delta_{0}\left(S_{0}\right)=1 \\
                &\delta_{0}\left(S_{i}\right)=0 \quad \forall i>0
                \end{aligned}
                \]
                Where:
                <ul>
                    {% for state in hidden_states %}
                    <li>S<sub>{{ loop.index }}</sub> = {{ state }}</li>
                    {% endfor %}
                </ul>
                <br>
                &delta;<sub>0</sub> (S<sub>0</sub>) = 1 <br>
                {% for state in hidden_states %}
                &delta;<sub>0</sub> (S<sub>{{ loop.index }}</sub>) = 0 <br>
                {% endfor %}
                {{ viterbi_init_text }}
                <br><br>
                <p class="card-text h4">Recursion</p><br>
                \[
                \begin{aligned}
                &\delta_{t}\left(S_{i}\right)=\pi_{i} \cdot e_{q_{t}=s_{i}}\left(O_{t}\right) \quad 1 \leq i \leq N, \quad t=1 \\
                &\delta_{1}\left(S_{i}\right)=\pi_{i} \cdot e_{q_{1}=s_{i}}\left(O_{1}\right) \quad 1 \leq i \leq N
                \end{aligned}
                \]
                \[
                \begin{array}{r}
                \delta_{t}\left(S_{j}\right)=e_{q_{t}=s_{j}}\left(O_{t}\right) \cdot \max _{i}\left[\delta_{t-1}\left(S_{i}\right) \cdot a_{i j}\right] \quad 2 \leq t \leq L \\
                1 \leq j \leq N
                \end{array}
                \]
                \[
                ptr_{t}\left(S_{j}\right)=\arg \max _{i}\left[\delta_{t-1}\left(S_{i}\right) \cdot a_{i j}\right]
                \]
                {{ viterbi_rec_text }}
                <br><br>
                <p class="card-text h4">Backtracking</p><br>
                <div class="content">
                    <ol>
                        <li>Each cell shows the delta corresponding to the particular hidden state at a particular
                            position
                            of the observed sequence.
                        </li>
                        <li>In green is shown the calculated backtracking.</li>
                        <li>The backtracking starts on letter ({{ observed_chain[-1] }}) at the last position, going
                            back to
                            the first letter ({{ observed_chain[0] }}) at the first position.
                        </li>
                    </ol>
                </div>
                <p class="card-text h4">Matrix of &delta; values</p><br>
                <div class="table-responsive">
                    {{ viterbi_matrix }}
                </div>
                <br>
                <p class="card-text h4">Termination</p><br>
                \[
                \begin{aligned}
                &P(O \cdot Q)=\max _{i}\left[\delta_{L}\left(S_{i}\right) \cdot a_{i 0}\right] \\
                &q_{L}^{*}=\arg \max _{i}\left[\delta_{L}\left(S_{i}\right) \cdot a_{i 0}\right]
                \end{aligned}
                \]
                {{ viterbi_term_text }}
            </div>
            {% endif %}
            {% if 'ba' in alg %}
            <div class="tab-pane fade" id="backward" role="tabpanel" aria-labelledby="backward-tab">
                <h1 class="card-title">Backward</h1>
                <p class="card-text h4">Initialization</p>
                {{ backward_intro_text }}
                <br><br>
                <p class="card-text h4">Initialization</p><br>
                \[
                \beta(L, k)=1 \quad \forall k, k=1 . . N
                \]
                <div class="content">
                    <ol>
                        <li>The length of observed sequence is: {{ observed_chain|length }}.</li>
                        <li>The probability of &beta; in the last state will be 1.</li>
                        <li>There are {{ hidden_states|length }} hidden states.</li>
                    </ol>
                </div>
                {% for state in hidden_states %}
                &beta;({{ observed_chain|length }},{{ loop.index }}) = 1 <br>
                {% endfor %}
                {{ backward_rec_text }}
                <br><br>
                <p class="card-text h4">Termination</p><br>
                \[
                P\left(q_{t^{*}}=S_{k} \mid O\right)=\frac{\alpha\left(t^{*}, k\right) \cdot \beta\left(t^{*}, k\right)}{P(O)}
                \]
                {{ backward_ter_text }}
                <br>
                <p class="card-text h4">Plot</p><br>
                {{ plot_bokeh_div }}
                {{ plot_bokeh_script }}
                <br>
                <p class="card-text h4">Matrix of &beta; values</p><br>
                <div class="table-responsive">
                    {{ forward_backward_matrix }}
                </div>
            </div>
            {% endif %}
            {% endfor %}
        </div>
    </div>
</div>
<div class="container">
    <footer class="py-1 my-2">
        <p class="text-center"><a href="https://www.mobilomics.org/">mobilomics.org</a> - © {{ year }}
            <br>
            <a href="http://icb.utalca.cl/">School of Bioinformatics Engineering</a> | Department of
            Bioinformatics | <a href="http://www.utalca.cl/">Universidad de Talca</a> | Talca, Chile
        </p>
        <p class="text-center">
            <strong>HMMTeacher</strong> was developed by Camilo Fuentes Beals at the Biological Sequence Analysis group,
            in the Center for Bioinformatics, Simulation and Modeling, CBSM, at the University of Talca, Chile. - {{
            year }}.
        </p>
    </footer>
</div>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-U1DAWAznBHeqEIlVSCgzq+c9gqGAJn5c/t99JyeKa9xxaYpSvHU5awsuZVVFIhvj"
        crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bokeh/2.3.3/bokeh.min.js"
        integrity="sha512-NsH0ToDGmmCEUnRv2Z17RdXWHa/4majB/3eIddT/o3EM7IS4/34Y3QdwJr2Qgw2MRnQaPUkiUtHikdTiVAeOjQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<script>
    MathJax = {
        displayMath: [             // start/end delimiter pairs for display math
            ['$$', '$$'],
            ['\\[', '\\]']
        ],
        chtml: {
            scale: 2
        },
        svg: {
            scale: 2
        }
    };
</script>
<script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
</body>
</html>